/*Select emp by empNo*/
SELECT OBJECTS.OBJECT_ID AS empNo, OBJECTS.NAME AS ename, job.TEXT_VALUE AS job,
mrg.NUMBER_VALUE AS mrg, hiredate.DATE_VALUE AS hiredate, sal.NUMBER_VALUE AS sal,
comm.NUMBER_VALUE AS comm, dept.NUMBER_VALUE AS deptno, version.NUMBER_VALUE AS version
FROM OBJECT_TYPES
JOIN OBJECTS ON OBJECT_TYPES.OBJECT_TYPE_ID = OBJECTS.OBJECT_TYPE_ID
JOIN ATTRIBUTES job_attr ON job_attr.NAME = 'JOB'
JOIN PARAMS job ON job.ATTR_ID = job_attr.ATTR_ID AND job.OBJECT_ID = OBJECTS.OBJECT_ID
JOIN ATTRIBUTES mrg_attr ON mrg_attr.NAME = 'MRG'
JOIN PARAMS mrg ON mrg.ATTR_ID = mrg_attr.ATTR_ID AND mrg.OBJECT_ID = OBJECTS.OBJECT_ID
JOIN ATTRIBUTES hiredate_attr ON hiredate_attr.NAME = 'HIRE_DATE'
JOIN PARAMS hiredate ON hiredate.ATTR_ID = hiredate_attr.ATTR_ID AND hiredate.OBJECT_ID = OBJECTS.OBJECT_ID
JOIN ATTRIBUTES sal_attr ON sal_attr.NAME = 'SALL'
JOIN PARAMS sal ON sal.ATTR_ID = sal_attr.ATTR_ID AND sal.OBJECT_ID = OBJECTS.OBJECT_ID
JOIN ATTRIBUTES comm_attr ON comm_attr.NAME = 'COMM'
JOIN PARAMS comm ON comm.ATTR_ID = comm_attr.ATTR_ID AND comm.OBJECT_ID = OBJECTS.OBJECT_ID
JOIN ATTRIBUTES dept_attr ON dept_attr.NAME = 'DEPT_NO'
JOIN PARAMS dept ON dept.ATTR_ID = dept_attr.ATTR_ID AND dept.OBJECT_ID = OBJECTS.OBJECT_ID
JOIN ATTRIBUTES version_attr ON version_attr.NAME = 'VERSION'
JOIN PARAMS version ON version.ATTR_ID = version_attr.ATTR_ID AND version.OBJECT_ID = OBJECTS.OBJECT_ID
WHERE OBJECT_TYPES.NAME = 'EMP' AND OBJECTS.OBJECT_ID = ;

/*select version of employee by empNo*/
SELECT version.NUMBER_VALUE AS version
FROM OBJECT_TYPES
JOIN OBJECTS ON OBJECT_TYPES.OBJECT_TYPE_ID = OBJECTS.OBJECT_TYPE_ID
JOIN ATTRIBUTES version_attr ON version_attr.NAME = 'VERSION'
JOIN PARAMS version ON version.ATTR_ID = version_attr.ATTR_ID AND version.OBJECT_ID = OBJECTS.OBJECT_ID
WHERE OBJECT_TYPES.NAME = 'EMP' AND OBJECTS.OBJECT_ID = ;

/*get empNo of all employees*/
SELECT OBJECTS.OBJECT_ID AS empNo
FROM OBJECT_TYPES
JOIN OBJECTS ON OBJECT_TYPES.OBJECT_TYPE_ID = OBJECTS.OBJECT_TYPE_ID
WHERE OBJECT_TYPES.NAME = 'EMP';

/*Delect dept by deptNo*/
SELECT OBJECTS.OBJECT_ID AS deptNo, OBJECTS.NAME AS dname, loc.TEXT_VALUE AS loc,
version.NUMBER_VALUE AS version
FROM OBJECT_TYPES
JOIN OBJECTS ON OBJECT_TYPES.OBJECT_TYPE_ID = OBJECTS.OBJECT_TYPE_ID
JOIN ATTRIBUTES loc_attr ON loc_attr.NAME = 'LOC'
JOIN PARAMS loc ON loc.ATTR_ID = loc_attr.ATTR_ID AND loc.OBJECT_ID = OBJECTS.OBJECT_ID
JOIN ATTRIBUTES version_attr ON version_attr.NAME = 'VERSION'
JOIN PARAMS version ON version.ATTR_ID = version_attr.ATTR_ID AND version.OBJECT_ID = OBJECTS.OBJECT_ID
WHERE OBJECT_TYPES.NAME = 'DEPT' AND OBJECTS.OBJECT_ID = ;

/*select salgrade for sal*/
SELECT grade.NUMBER_VALUE AS grade, losal.NUMBER_VALUE AS losal, hisal.NUMBER_VALUE AS hisal
FROM OBJECT_TYPES
JOIN OBJECTS ON OBJECT_TYPES.OBJECT_TYPE_ID = OBJECTS.OBJECT_TYPE_ID
JOIN ATTRIBUTES grade_attr ON grade_attr.NAME = 'GRADE'
JOIN PARAMS grade ON grade.ATTR_ID = grade_attr.ATTR_ID AND grade.OBJECT_ID = OBJECTS.OBJECT_ID
JOIN ATTRIBUTES losal_attr ON losal_attr.NAME = 'LOSAL'
JOIN PARAMS losal ON losal.ATTR_ID = losal_attr.ATTR_ID AND losal.OBJECT_ID = OBJECTS.OBJECT_ID
JOIN ATTRIBUTES hisal_attr ON hisal_attr.NAME = 'HISAL'
JOIN PARAMS hisal ON hisal.ATTR_ID = hisal_attr.ATTR_ID AND hisal.OBJECT_ID = OBJECTS.OBJECT_ID
WHERE OBJECT_TYPES.NAME = 'SALEGRADE' AND hisal.NUMBER_VALUE >= 3001 AND losal.NUMBER_VALUE <= 3001;